* ****************************************************************
*                  PIRATE ADVENTURE
* SCENARIO AND DATA BASE:  SCOTT & ALEXIS ADAMS, 1978
* PROGRAMMING ON HP48: J-F GARNIER, 1994  <version B, 22/10/94>
*
* ****************************************************************
* trobj.s


ASSEMBLE
        NIBASC 'HPHP48-A'
RPL

INCLUDE DEFVAR.INC


* *****************************************************
*        trobj
* action :
*    traitement des objets
* entres :
*    2: n0
*    1: n1
* sortie :
*    1: flag true si traitement pas ok
* utilise :
*   NV2S
*   I0S
* appelle:
*   WRTSTR
*   PUTSB
* *****************************************************

::
  OVER TEN #<>
  3PICK EIGHTEEN #<> ANDITE
  ::
    2DROP
    TRUE  ( return )
  ;
  ::
    DUP#0=ITE
    ::
      2DROP
      ID MSG EIGHTEEN NTHCOMPDROP       ( WHAT? )
      ID WRTSTR
    ;
    ::
      OVER TEN #=ITE
      ::
        ZERO
        SIXTY #1+_ONE_DO (DO)
          INDEX@ GET_I3 GETATELN DROP
          MINUSONE #= IT #1+
        LOOP
        FIVE #<ITE
          FALSE
        ::
          ID MSG ELEVEN NTHCOMPDROP   ( I HAVE TOO MUCH TO CARRY )
          ID WRTSTR
          TRUE  ( exit )
        ;
      ;
        FALSE
      ITE
         2DROP
      ::
        ID NV2S OVER #2* #2* #2+
        DUP #2+ SUB$    ( "objet" )
        ID I0S
        SWAP
        ONE ZERO  ( I0S "objet" pos K )
        BEGIN
          BEGIN
            ( recherche objet s dans I0S )
            4PICK 4PICK  ( I0S "objet" pos K I0S "objet" )
            4ROLL
            POS$
            DUP#0=ITE
              TRUE ( flag sortie )
            ::
              DUP
              THREE #/ DROP ( modulo )
              ONE #=
            ;
          UNTIL
          DUP #1+ ( ... K pos pos' )
          UNROT   ( ... pos' K pos )
          DUP#0=ITE
            DROPTRUE ( flag sortie )
          ::
            THREE #/ SWAPDROP #1+ ( X )
            ( ici, on a : n0 n1 I0S "objet" pos K X )
            7PICK ( n0 )
            TEN #=ITE
            ::
              DUP GET_I3 GETATELN DROP
              GET_R #=ITE
              ::
                GET_I3 SWAP MINUSONE ID PUTSB DROP
                DROP THREE ( K=3 )
              ;
              ::
                2DROP TWO ( K=2 )
              ;
            ;
            ::
              DUP GET_I3 GETATELN DROP
              MINUSONE #=ITE
              ::
                GET_I3 SWAP GET_R ID PUTSB DROP
                DROP THREE ( K=3 )
              ;
              ::
                2DROP ONE ( K=1 )
              ;
            ;
            DUP
            THREE #=
          ;
        UNTIL
        ( ici, on a : n0 n1 I0S "objet" pos K )
        6UNROLL 5DROP  ( reste K )
        DUP#0=ITE
          TWENTY           ( ITS BEYOND MY POWER TO DO THAT )
        ::
          DUP ONE #=ITE
            TWENTYONE      ( I'M NOT CARRYING IT )
          ::
            DUP TWO #=ITE
              TWENTYTWO    ( I DON'T SEE IT HERE )
              NINETEEN     ( OK. )
          ;
        ;
        ID MSG SWAP NTHCOMPDROP
        ID WRTSTR
        DROP
      ;
    ;
    FALSE
  ;
;
