* ****************************************************************
*                  PIRATE ADVENTURE
* SCENARIO AND DATA BASE:  SCOTT & ALEXIS ADAMS, 1978
* PROGRAMMING ON HP48: J-F GARNIER, 1994  <version B, 22/10/94>
*
* ****************************************************************
* analg.s



ASSEMBLE
        NIBASC 'HPHP48-A'
RPL



* *****************************************************
*        analg
* action :
*  analyse la ligne saisie, et en extrait les codes des mots reconnus
* entres :
*  niveau 1 : chaine contenant la ligne  analyser
* sortie :
*  si 1 ou 2 mots valides:
*   niveau 3 : code mot1
*   niveau 2 : code mot2 (0 si 1 seul mot)
*   niveau 1 : TRUE
*  sinon
*   niveau 1 : FALSE
* objets globaux utilises:
*   NV1S : chaine contenant la liste des 1ers mots cls
*   NV2S : chaine contenant la liste des 2mes mots cls
* appelle :
*   CHMOT: programme de recherche d'un mot dans une liste
* *****************************************************


::
* cherche le 1er mot
  DUP
  ONE THREE
  SUB$
  ID NV1S
  SWAP
  ID CHMOT
  DUP
  #0=        ( "ligne" n1 f )
  ITE
  ::
* pas trouv, erreur
    2DROP
    FALSE
  ;
  ::
* cherche l'espace sparant les 2 mots
    SWAP      ( n1 "ligne" )
    DUP
    SPACE$
    ONE
    POS$
    DUP
    #0=        ( n1 " ligne" pos f )
    ITE
    ::
* pas d'espace, trouv un seul mot.
      2DROP
      ZERO      ( pas de second mot )
      TRUE
    ;
    ::
      DUP
      #1+
      SWAP
      #3+    ( n1 "ligne" pos+1 pos+3 )
      SUB$
      ID NV2S
      SWAP
      ID CHMOT  ( n1 n2 )
      DUP
      #0=
      ITE
      ::
* pas trouv, erreur
        2DROP
        FALSE
      ;
        TRUE    ( 2 mots trouvs )
    ;
  ;
;





