* ****************************************************************
*                  PIRATE ADVENTURE
* SCENARIO AND DATA BASE:  SCOTT & ALEXIS ADAMS, 1978
* PROGRAMMING ON HP48: J-F GARNIER, 1994  <version B, 22/10/94>
*
* ****************************************************************
* chmot.s


ASSEMBLE
        NIBASC 'HPHP48-A'
RPL



* *****************************************************
*        chmot
* action :
*  recherche d'un mot cl dans une liste
* entres :
*  niveau 2 : chaine contenant la liste des mots cls
*  niveau 1 : chaine contenant le mot  chercher
* sortie :
*  niveau 1 : index du mot primaire ou 0 si non trouv
* *****************************************************

::
  DUPNULL$?
  ITE
  ::
* si mot vide, retourne 0
    2DROP
    ZERO
  ;
  ::
    ONE    ( position de dpart de la recherche )
*   ici, on a : "liste" "mot" 1
    BEGIN
* duplique "liste" et "mot"
      3PICK3PICK    ( X Y Z --> X Y Z X Y )
      ROT           (           X Y X Y Z )
      POS$     ( "liste" "mot" position )
      DUP#0=ITE
      TRUE        ( flag de sortie de la boucle )
      ::
        DUP
        THREE #AND    ( modulo 4 )
        TWO #=ITE
        TRUE
        ::
          #1+
          FALSE
        ;
      ;
    UNTIL
    SWAPDROP      ( oublie le mot )
    DUP#0<>
    IT
    ::
      #1-
      BEGIN
        2DUP
        SUB$1#
        FORTYTWO    ( 42 = code ascii de '*' )
        #=
      WHILE
        FOUR #-
      REPEAT
      #1-
      FOUR #/ SWAPDROP  ( oublie le reste )
    ;
    SWAPDROP        ( oublie la liste )
  ;
;
