* ****************************************************************
*                  PIRATE ADVENTURE
* SCENARIO AND DATA BASE:  SCOTT & ALEXIS ADAMS, 1978
* PROGRAMMING ON HP48: J-F GARNIER, 1994  <version B, 22/10/94>
*
* ****************************************************************
* pirmain.s


ASSEMBLE
        NIBASC 'HPHP48-A'
RPL

INCLUDE DEFVAR.INC


* *****************************************************
*        pirmain
* action :
*  programme principal de PIRATE
* entres :
* sortie :
* utilise
*   I2
*   PIRDATA
* appelle:
*   WELCOME
*   CLRSCR
*   AFFI1
*   GETS
*   ANALG
*   DESCR
*   TRAITE
*
* *****************************************************
::

  ClrDA1IsStat          ( *Suspend clock display updates* )
  RECLAIMDISP           ( *Assert & clear alpha display* )
  TURNMENUOFF           ( *Remove menu keys* )

  ( crans de bienvenu )
  ID WELCOME

  ( cr les variables locales )
  FIFTY
  FALSE
  FALSE
  FALSE
  { SEVENTEEN } ZERO MAKEARRY
  ID I2  TOTEMPOB
  ONE
  FALSE
  NULL{}
*  {
*    LAM W
*    LAM L3   ( temporisation lumire )
*    LAM D0   ( flag obscurit )
*    LAM F2   ( flag )
*    LAM F    ( flag )
*    LAM SF   ( indicateurs 0/1 )
*    LAM I3   ( emplacement des objets )
*    LAM R    ( lieu courant )
*    LAM Fin  ( flag fin du jeu )
*    LAM SCRBUF
*  }
  NULLLAM TEN NDUPN {}N
  BIND


  ( rappel de la dernire sauvegarde, si elle existe )
  ' ID PIRDATA SAFE@_HERE IT
  ::
    INNERCOMP
    FIVE #= IT
    ::
      PUT_R
* TOTEMPOB ncessaire, car Bang operations (PUTSB)
      TOTEMPOB PUT_I3
      TOTEMPOB PUT_SF
      PUT_D0
      PUT_L3
    ;
  ;

  ID DESCR                              ( affiche 1re description )
  ID TRAI0                              ( traite 1ers venements )

  ( boucle gnrale du prog. )
  BEGIN
    ID MSG TWO NTHCOMPDROP ID AFFI1     ( COMMAND : )
    FORTY FIFTYEIGHT ID GETS            ( saisie commande )
    NULL$ ID AFFI1                      ( efface ligne de saisie )
    ID ANALG                            ( analyse ligne )
    ITE
    ::
      ID TRAI2                          ( traite commande )
      ID TRLIG                          ( traite lumiere )
      ID TRAI0                          ( traite venements )
    ;
    ::
      ID MSG THREE NTHCOMPDROP ID AFFI1 ( YOU USE WORDs I DON'T KNOW. )
      WaitForKey 2DROP
    ;
    GET_Fin
  UNTIL

  ID MSG FOUR NTHCOMPDROP ID WRTSTR     ( THE GAME IS NOW OVER. )

  ID MSG TWENTYSEVEN NTHCOMPDROP ID AFFI1  ( PRESS ANY KEY TO CONTINUE )
  WaitForKey 2DROP

  ABND

  ClrDAsOK            ( *Tell the 48 to redraw the lcd* )

;
